#include <algorithm>
#include <cstdio>
#include <utility>
#include <functional>
using namespace std;
#define maxN 100000
#define maxS 262144
#define lli long long int
#define pli pair<lli, int>
#define max(a, b) a>b?a:b
#define F first
#define S second

int n;
lli h[maxN];
lli l[maxN];
lli r[maxN];
lli c[maxN];

pli maxl[maxS];
pli maxr[maxS];
lli seg[maxS];
pli a[maxN];

void build_seg() {
  int s = maxS >> 1;
  for (int i = 0; i < n; i++) {
    seg[s + i] = c[i];
    maxl[s + i] = make_pair(-1, i);
    maxr[s + i] = make_pair(-1, i);
  }
  maxl[s].first = 0;
  maxr[s + n - 1].first = 0;
  for (int i = s - 1; i > 0; i--) {
    seg[i] = seg[i << 1] + seg[(i << 1) + 1];
    maxl[i] = max(maxl[i << 1], maxl[(i << 1) + 1]);
    maxr[i] = max(maxr[i << 1], maxr[(i << 1) + 1]);
  }
}

void update(int p) {
  p += maxS >> 1;
  seg[p] = 0;
  p >>= 1;
  while (p > 0) {
    seg[p] = seg[p << 1] + seg[(p << 1) + 1];
    p >>= 1;
  }
}

lli query(int a, int b, int l, int s, int p) {
  if (s == 0 || (a == l && b == l + (s << 1) + 1))
    return seg[p];
  if (a >= l + s)
    return query(a, b, l + s, s >> 1, (p << 1) + 1);
  if (b < l + s)
    return query(a, b, l, s >> 1, p << 1);
  lli tmp1 = query(a, l + s - 1, l, s >> 1, p << 1);
  lli tmp2 = query(l + s, b, l + s, s >> 1, (p << 1) + 1);
  return tmp1 + tmp2;
}

void update_maxl(int p, lli x) {
  p += maxS >> 1;
  maxl[p].F = x;
  p >>= 1;
  while (p > 0) {
    maxl[p] = max(maxl[p << 1], maxl[(p << 1) + 1]);
    p >>= 1;
  }
}

void update_maxr(int p, lli x) {
  p += maxS >> 1;
  maxr[p].first = x;
  p >>= 1;
  while (p > 0) {
    maxr[p] = max(maxr[p << 1], maxr[(p << 1) + 1]);
    p >>= 1;
  }
}

pli query_maxl(int a, int b, int l, int s, int p) {
  if (s == 0 || (a == l && b == l + (s << 1) + 1))
    return maxl[p];
  if (a >= l + s)
    return query_maxl(a, b, l + s, s >> 1, (p << 1) + 1);
  if (b < l + s)
    return query_maxl(a, b, l, s >> 1, p << 1);
  pli tmp1 = query_maxl(a, l + s - 1, l, s >> 1, p << 1);
  pli tmp2 = query_maxl(l + s, b, l + s, s >> 1, (p << 1) + 1);
  return max(tmp1, tmp2);
}

pli query_maxr(int a, int b, int l, int s, int p) {
  if (s == 0 || (a == l && b == l + (s << 1) + 1))
    return maxr[p];
  if (a >= l + s)
    return query_maxr(a, b, l + s, s >> 1, (p << 1) + 1);
  if (b < l + s)
    return query_maxr(a, b, l, s >> 1, p << 1);
  pli tmp1 = query_maxr(a, l + s - 1, l, s >> 1, p << 1);
  pli tmp2 = query_maxr(l + s, b, l + s, s >> 1, (p << 1) + 1);
  return max(tmp1, tmp2);
}
/*
8
1771 25 14 13
1270 21 24 16
1018 19 23 24
1729 26 25 16
1817 18 26 22
1861 26 13 18
1541 19 20 23
1645 25 14 17
*/
/*
10
1041 18 23 27
1169 29 16 29
1962 14 23 23
1281 27 29 28
1995 21 29 26
1391 14 22 13
1815 19 26 29
1718 18 20 13
1771 25 29 18
1837 15 14 26
*/

int main() {
  scanf("%d", &n);
  for (int i = 0; i < n; i++) {
    scanf("%lld %lld %lld %lld", &h[i], &c[i], &l[i], &r[i]);
    a[i] = make_pair(h[i], i);
  }
  build_seg();
  sort(a, a + n);
  for (int i = 0; i < n; i++) {
    int id = a[i].second;
    //update(id);
    pli left = query_maxl(0, id, 0, maxS >> 2, 1);
    pli right = query_maxr(id, n - 1, 0, maxS >> 2, 1);
    //lli profitleft = left.first - query(left.S, id, 0, maxS >> 2, 1) + l[id];
    //lli profitright = right.first - query(id, right.S, 0, maxS >> 2, 1) + r[id];
    lli profitleft = left.first + l[id];
    lli profitright = right.first + r[id];
    /*printf("%d: id = %d, left = (%lld, %d), right = (%lld, %d), profitleft = %lld, profitright = %lld\n   query_left = %lld, query_right = %lld\n", i, id, left.F, left.S, right.F, right.S,
           profitleft, profitright, query(left.S, id, 0, maxS >> 2, 1), query(id, right.S, 0, maxS >> 2, 1));*/
    update_maxl(id, profitleft);
    update_maxr(id, profitright);
  }/*
  for (int i = 0; i < n; i++) {
    printf("%lld, ", maxl[(maxS >> 1) + i]);
  }
  printf("\n");
  for (int i = 0; i < n; i++) {
    printf("%lld, ", maxr[(maxS >> 1) + i]);
  }
  printf("\n");*/
  lli mx = 0;
  for (int i = 0; i < n; i++) {
    lli left = query_maxl(0, i, 0, maxS >> 2, 1).first;
    lli right = query_maxr(i, n - 1, 0, maxS >> 2, 1).first;
    if (left + right > mx)
      mx = left + right;
  }
  printf("%lld\n", mx);
  return 0;
}