#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;
#define maxN 200000
#define max(a, b) a>b?a:b

int n;
vector<int> g[maxN];
vector<int> vec[maxN];
int root;
int leaves;
int sz[maxN];


void dfs(int cur, int pr) {
  if (g[cur].size() == 1) {
    sz[cur] = 1;
    return;
  }
  for (int i = 0; i < g[cur].size(); i++)
    if (g[cur][i] != pr) {
      dfs(g[cur][i], cur);
      sz[cur] += sz[g[cur][i]];
    }
}

int go(int cur, int pr) {
  int mx = 0;
  int mxi = -1;
  for (int i = 0; i < g[cur].size(); i++)
    if (g[cur][i] != pr)
      if (sz[g[cur][i]] > mx) {
        mx = sz[g[cur][i]];
        mxi = i;
      }
  if (mx > leaves / 2)
    return go(g[cur][mxi], cur);
  return cur;
}

void dfs2(int cur, int pr, int id) {
  if (g[cur].size() == 1) {
    vec[id].push_back(cur);
    return;
  }
  for (int i = 0; i < g[cur].size(); i++)
    if (g[cur][i] != pr)
      dfs2(g[cur][i], cur, id);
}

void solution() {
  sort(g[root].begin(), g[root].end());
  printf("root = %d\n", root + 1);
  for (int i = 0; i < g[root].size(); i++) {
    for (int j = 0; j < vec[i].size(); j++)
      printf("%d, ", vec[i][j] + 1);
    printf("\n");
  }
}

int main() {
  scanf("%d", &n);
  int tmpa, tmpb;
  if (n == 1) {
    printf("0\n");
    return 0;
  }
  if (n == 2) {
    printf("1\n1 2\n");
    return 0;
  }
  for (int i = 1; i < n; i++) {
    scanf("%d %d", &tmpa, &tmpb);
    tmpa--;
    tmpb--;
    g[tmpa].push_back(tmpb);
    g[tmpb].push_back(tmpa);
  }
  for (int i = 0; i < n; i++)
    if (g[i].size() > 1) {
      root = i;
      break;
    }
  dfs(root, -1);
  leaves = sz[root];
  root = go(root, -1);
  for (int i = 0; i < g[root].size(); i++)
    dfs2(g[root][i], root, i);
  printf("%d\n", (leaves + 1) / 2);
  solution();
  return 0;
}