#include <cstdio>
#include <vector>
#include <queue>
#include <utility>
#include <algorithm>
using namespace std;
#define maxN 200000
#define max(a, b) a>b?a:b
#define pii pair<int, int>

void inf() {
  int a = -1;
  while (true)
    a = -1;
}

int n;
vector<int> g[maxN];
vector<int> vec[maxN];
pii a[maxN];
int root;
int leaves;
int sz[maxN];
priority_queue<pii> pq;

void dfs(int cur, int pr) {
  if (g[cur].size() == 1) {
    sz[cur] = 1;
    return;
  }
  for (int i = 0; i < g[cur].size(); i++)
    if (g[cur][i] != pr) {
      dfs(g[cur][i], cur);
      sz[cur] += sz[g[cur][i]];
    }
}

int go(int cur, int pr) {
  int mx = 0;
  int mxi = -1;
  for (int i = 0; i < g[cur].size(); i++)
    if (g[cur][i] != pr)
      if (sz[g[cur][i]] > mx) {
        mx = sz[g[cur][i]];
        mxi = i;
      }
  if (mx > leaves / 2)
    return go(g[cur][mxi], cur);
  return cur;
}

void dfs2(int cur, int pr, int id) {
  if (g[cur].size() == 1) {
    vec[id].push_back(cur);
    return;
  }
  for (int i = 0; i < g[cur].size(); i++)
    if (g[cur][i] != pr)
      dfs2(g[cur][i], cur, id);
}

void print(int a, int b) {
  printf("%d %d\n", vec[a][vec[a].size() - 1] + 1, vec[b][vec[b].size() - 1] + 1);
  vec[a].pop_back();
  vec[b].pop_back();
}

void solution() {
  for (int i = 0; i < g[root].size(); i++)
    pq.push(make_pair(vec[i].size(), i));
  pii ta, tb;
  while (leaves > 1) {
    ta = pq.top();
    pq.pop();
    tb = pq.top();
    pq.pop();
    print(ta.second, tb.second);
    if (ta.first > 1)
      pq.push(make_pair(ta.first - 1, ta.second));
    if (tb.first > 1)
      pq.push(make_pair(tb.first - 1, tb.second));
    leaves -= 2;
  }
  if (leaves == 1) {
    ta = pq.top();
    printf("%d %d\n", vec[ta.second][0] + 1, root + 1);
  }
}

int main() {
  scanf("%d", &n);
  int tmpa, tmpb;
  if (n == 1) {
    printf("0\n");
    return 0;
  }
  if (n == 2) {
    printf("1\n1 2\n");
    return 0;
  }
  for (int i = 1; i < n; i++) {
    scanf("%d %d", &tmpa, &tmpb);
    tmpa--;
    tmpb--;
    g[tmpa].push_back(tmpb);
    g[tmpb].push_back(tmpa);
  }
  for (int i = 0; i < n; i++)
    if (g[i].size() > 1) {
      root = i;
      break;
    }
  dfs(root, -1);
  for (int i = 0; i < n; i++) {
    if (g[i].size() == 1)
      leaves++;
  }
  leaves = sz[root];
  root = go(root, -1);
  int mx = -1;
  for (int i = 0; i < g[root].size(); i++) {
    dfs2(g[root][i], root, i);
    if (vec[i].size() > leaves / 2)
      inf();
  }

  printf("%d\n", (leaves + 1) / 2);
  solution();
  return 0;
}