#include <bits/stdc++.h>

using namespace std;
const int MAX_N=5100;
vector<int> graf[MAX_N];
int degree[MAX_N];
queue<int> leafs[MAX_N];
vector<int> parents[MAX_N];
int n;
struct node
{
    int parent;
    int rank;
};
node DSU[MAX_N];
void MakeSet(int x)
{
    DSU[x].parent=x;
    DSU[x].rank=0;
}
int Find(int x)
{
    if(DSU[x].parent==x)return x;
    DSU[x].parent=Find(DSU[x].parent);
    return DSU[x].parent;
}
void Union(int x,int y)
{
    int xRoot=Find(x);
    int yRoot=Find(y);
    if(xRoot==yRoot)return;
    if(DSU[xRoot].rank<DSU[yRoot].rank)
        DSU[xRoot].parent=yRoot;
    else if(DSU[xRoot].rank>DSU[yRoot].rank)
        DSU[yRoot].parent=xRoot;
    else
    {
        DSU[xRoot].rank++;
        DSU[yRoot].parent=xRoot;
    }
}
vector<pair<int,int> > solution;
void UnionVectors(int u,int child)
{
    while(!leafs[child].empty())
    {
        int leaf=leafs[child].front();
        leafs[child].pop();
        leafs[u].push(leaf);
    }
    while(leafs[u].size()>=3)
    {
        int first=leafs[u].front();
        leafs[u].pop();
        int second=leafs[u].front();
        leafs[u].pop();
        solution.push_back(make_pair(first,second));
    }
}
void topoSort()
{
    queue<int> q;
    for(int i=0;i<n;i++)
        if(degree[i]==1)q.push(i);
    int last=-1;
    while(!q.empty())
    {
        int u=q.front();
        //printf("NODE %d\n",u);
        last=u;
        q.pop();
        for(int i=0;i<parents[u].size();i++)
        {
            Union(u,parents[u][i]);
            UnionVectors(u,parents[u][i]);
        }
        for(int i=0;i<graf[u].size();i++)
        {
            int v=graf[u][i];
            degree[v]--;
            parents[v].push_back(u);
            if(degree[v]==1)q.push(v);
        }
    }
    while(leafs[last].size()>=1)
    {
        int first=leafs[last].front();
        leafs[last].pop();
        solution.push_back(make_pair(first,0));
    }
}

int main()
{
    scanf("%d",&n);
    for(int i=0; i<n-1; i++)
    {
        int u,v;
        scanf("%d%d",&u,&v);
        u--;
        v--;
        graf[u].push_back(v);
        graf[v].push_back(u);
        degree[u]++;
        degree[v]++;
    }
    for(int i=0;i<n;i++)
        MakeSet(i);
    for(int i=0;i<n;i++)
        if(degree[i]==1)leafs[i].push(i);
    topoSort();
    printf("%d\n",solution.size());
    for(int i=0;i<solution.size();i++)
        printf("%d %d\n",solution[i].first+1,solution[i].second+1);
    return 0;
}