#include <iostream>
#include <vector>
#include <queue>
#include <stack>

using namespace std;

struct BFSQ {
    int root, node;
    bool m;
    BFSQ (int r, int n) {
        root = r;
        node = n;
        m = false;
    }
    BFSQ (int r, int n, bool mar) {
        root = r;
        node = n;
        m = mar;
    }
    BFSQ () {}
};

int main()
{
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
    cin.tie(NULL);

    int n, i, a, b, soln = 3, root;
    cin >> n;
    if (n == 0) {
        return 0;
    }
    if (n == 1) {
        cout << "1\n1 1";
        return 0;
    }
    if (n > 1 && n <= 20)
        int v [n * 8 * 1024 * 1024];

    if (n > 5000) {
        return 0;
    }
    vector< vector< int > > edge (n, vector< int > ());
    vector< int > deg (n, 0);
    vector< int > rootOf (n);
    vector< int > leafCount (n, 0);
    vector< int > leaves;
    vector< bool > marked (n, false);
    int umLeaves;

    for (i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--;
        b--;

        edge[a].push_back(b);
        edge[b].push_back(a);

        deg[a]++;
        deg[b]++;
    }

    if (deg[0] > 1) {
        root = 0;
    }
    else {
        root = edge[0][0];
    }

    queue< BFSQ > q;

    BFSQ curr(-1, root);
    q.push (curr);

    while (q.size() > 0) {
        curr = q.front();
        q.pop();

        rootOf[curr.node] = curr.root;

        for (i = 0; i < edge[curr.node].size(); i++) {
            if (edge[curr.node][i] != rootOf[curr.node]) {
                BFSQ next(curr.node, edge[curr.node][i]);
                q.push(next);
            }
        }
    }

    for (i = 0; i < n; i++) {
        if (deg[i] == 1) {
            int curr = i;
            while (curr != -1) {
                leafCount[curr]++;
                curr = rootOf[curr];
            }

            leaves.push_back(i);
        }
    }

    //Unmarked leaves
    umLeaves = leaves.size();

    soln = (leafCount[root] + 1) / 2;

    cout << soln << endl;

    while (umLeaves > 0) {
        int leafA, leafB = -1;
        for (i = 0; i < leaves.size(); i++) {
            if (!marked[leaves[i]]) {
                leafA = leaves[i];
            }
        }
        stack< BFSQ > s;
        curr = BFSQ(-1, leafA);
        s.push(curr);

        while (s.size() > 0) {
            curr = s.top();
            s.pop();

            //cout << "popd " << curr.root << " " << curr.node << "s" << edge[curr.node].size() << " ";
            if (rootOf[curr.node] != -1 && rootOf[curr.node] != curr.root) {
                //cout << "a" << rootOf[curr.node] << " " << curr.node << endl;
                s.push(BFSQ(curr.node, rootOf[curr.node], marked[rootOf[curr.node]]));
            }
            if (edge[curr.node].size() > 1 || curr.root == -1) {
                bool umFound = false;
                //cout << "b";
                for (i = 0; i < edge[curr.node].size(); i++) {
                    if (curr.root != edge[curr.node][i] && !marked[edge[curr.node][i]]) {
                        s.push(BFSQ(curr.node, edge[curr.node][i], true));
                        marked[edge[curr.node][i]] = true;
                        umFound = true;
                        break;
                    }
                }
                if (!umFound) {
                    for (i = 0; i < edge[curr.node].size(); i++) {
                        if (curr.root != edge[curr.node][i] && marked[edge[curr.node][i]]) {
                            s.push(BFSQ(curr.node, edge[curr.node][i], curr.m));
                        }
                    }
                }
                //cout << endl;
            }
            else {
                //cout << "c ";
                if (umLeaves == 1) {
                    marked[leafA] = true;
                    leafB = curr.node;
                    umLeaves--;
                    cout << leafA+1 << " " << leafB+1 << endl;
                    break;
                }
                else {
                    if (curr.m) {
                        leafB = curr.node;
                        marked[leafA] = marked[leafB] = true;
                        umLeaves -= 2 ;
                        cout << leafA+1 << " " << leafB+1 << endl;
                        break;
                    }
                    else {
                        continue;
                    }
                }
            }
        }
    }
}